﻿%%FRAGMENTINPUT_STRUCT%%

%%FRAGMENTOUTPUT_STRUCT%%

%%SAMPLERFRONT_BINDING%% var samplerFront : sampler;
%%TEXTUREFRONT_BINDING%% var textureFront : texture_2d<f32>;

%%SAMPLERBACK_BINDING%% var samplerBack : sampler;
%%TEXTUREBACK_BINDING%% var textureBack : texture_2d<f32>;


struct ShaderParams {
	threshold : f32,
	lowThreshold : f32,
	brightness : f32,
	tint : vec3<f32>
};


%%SHADERPARAMS_BINDING%% var<uniform> shaderParams : ShaderParams;

%%C3PARAMS_STRUCT%%

%%C3_UTILITY_FUNCTIONS%%

fn luminance(rgb: vec3<f32>) -> f32 {
	let W: vec3<f32> = vec3<f32>(0.2125, 0.7154, 0.0721);
	return dot(rgb, W);
} 

@fragment
fn main(input : FragmentInput) -> FragmentOutput
{	
	var n: vec2<f32> = c3_getBackUV(input.fragPos.xy, textureBack);
	var back = textureSample(textureBack, samplerBack, n);
	var front = textureSample(textureFront, samplerFront, input.fragUV);
	
	var output: FragmentOutput;
	var color: vec3<f32> = vec3<f32>(0.,0.,0.) + back.rgb * smoothstep(shaderParams.threshold - shaderParams.lowThreshold, shaderParams.threshold, luminance(back.rgb)) * shaderParams.brightness;
	output.color = vec4<f32>(color * shaderParams.tint * front.a, front.a);
	return output;
}